<?php defined('SYSPATH') or die('No direct script access.');

class Model_Helper_DisciplineBuilder extends Model
{
    private $data;

    public function create() {
        if (count($this->data) != 9)  # fixme: bad const
            throw new InvalidArgumentException('not enough arguments');
        return new Model_Discipline($this->data, false);
    }

    function & author($id) {
        if (!is_numeric($id) || $id <= 0)
            throw new InvalidArgumentException('author id is incorrect');
        $this->data['authorID'] = (int) $id;
        return $this;
    }

    function & grade($id) {
        if (!is_numeric($id) || $id <= 0)
            throw new InvalidArgumentException('grade id is incorrect');
        $this->data['gradeID'] = (int) $id;
        return $this;
    }

    function & faculty($id) {
        if (!is_numeric($id) || $id <= 0)
            throw new InvalidArgumentException('faculty id is incorrect');
        $this->data['facultyID'] = (int) $id;
        return $this;
    }

    function & subject($id) {
        if (!is_numeric($id) || $id <= 0)
            throw new InvalidArgumentException('subject id is incorrect');
        $this->data['subjectID'] = (int) $id;
        return $this;
    }

    function & lectures($hours) {
        if (!is_numeric($hours) || $hours < 0)
            throw new InvalidArgumentException('lectures hours are incorrect');
        $this->data['lectures'] = (int) $hours;
        return $this;
    }

    function & practice($hours) {
        if (!is_numeric($hours) || $hours < 0)
            throw new InvalidArgumentException('practice hours are incorrect');
        $this->data['practice'] = (int) $hours;
        return $this;
    }

    function & labs($hours) {
        if (!is_numeric($hours) || $hours < 0)
            throw new InvalidArgumentException('labs hours are incorrect');
        $this->data['labs'] = (int) $hours;
        return $this;
    }

    function & type($name) {
        if (!$name)  // todo: enum
            throw new InvalidArgumentException('type is incorrect');
        $this->data['type'] = $name;
        return $this;
    }

    function & semester($id) {
        if (!is_numeric($id) || $id <= 0)
            throw new InvalidArgumentException('semester id is incorrect');
        $this->data['semesterID'] = (int) $id;
        return $this;
    }
}